import ChannelBase from './channels/channelBase';
import ClientBase from './clients/clientBase';
import MHSClient from './clients/sites/mhsClient';
import MHSChannel from './channels/sites/mhsChannel';

class ChannelManager {
  channels: ChannelBase[]|MHSChannel[] = [];

  constructor() {
    // create default channel...
    var channel: ChannelBase = new ChannelBase('default');
    this.channels.push(channel);
  }

  createChannel(data: any) {
    var channel: ChannelBase|MHSChannel|null = this.channelExists(data.channel_id);

    if (channel) {
      console.log('channel already exists');
    } else {
      var Channel = require(`./channels/${data.client_type}s/${data.client}channel`);
      var channel: ChannelBase|MHSChannel|null = new ChannelBase(data.channel_id);
      this.channels.push(channel);
      console.log('added channel to channel manager');
    }

    console.log(data.channel_id);
  }

  channelExists(channel_id: string) {
    for (let channel of this.channels) {
      if (channel.id == channel_id) {
        return channel;
      }
    }

    return null;
  }

  addClientToChannel(client: ClientBase|MHSClient, channel_id: string) {
    var channel: ChannelBase|MHSChannel|null = this.channelExists(channel_id);

    if (channel) {
      channel.addClient(client);
      client.connectToChannel(channel);
    } else {
      console.log(`channel with id ${channel_id} does not exist.`)
    }
  }
};

export default ChannelManager;

// { :client => 'mhs', :client_type => 'site', :user_id => 125, :user_type => 'user', :channel => 'mhs_1239' }
