import * as WebSocket from 'ws';
import * as ChannelManager from '../channelManager';
import ChannelBase from '../channels/channelBase';
import MHSChannel from '../channels/sites/mhsChannel';

class ClientBase {
  ws: WebSocket;
  data: any;
  id: number;
  channel: ChannelBase|MHSChannel|null;

  constructor(data: any, ws: WebSocket) {
    this.ws = ws;
    this.data = data;
    this.id = data.user_id;
    this.channel = null;
  }

  getData() {
    return this.data;
  }

  type() {
    return this.data.client_type;
  }

  connectToChannel(channel: ChannelBase|MHSChannel) {
    this.channel = channel;

    this.ws.on('message', (message: string) => {
      channel.broadcastMessage(this, message);
      console.log('broadcasted: %s', message);
    });
  }

  replaceWebSocket(ws: WebSocket) {
    this.ws.close();
    this.ws = ws;
  }
};

export default ClientBase;
